/************************************************************************/
/*	Project...:	Standard ANSI-C Library									*/
/*	Name......:	unix.h													*/
/*	Purpose...:	standard ANSI header file								*/
/*  Copyright.: Copyright 1994 by metrowerks inc. All rights reserved. */
/************************************************************************/

/*
 *	NB:	This file implements some UNIX low level support.  These functions
 *		are not guaranteed to be 100% conformant.
 */

#ifndef	_UNIX
#define	_UNIX

#if __MWERKS__
#pragma options align=mac68k
#endif

#ifndef _STDIO
#include <stdio.h>
#endif

/*
 * Mode values accessible to __open()
 */

#define O_RDWR			0x0
#define O_RDONLY		0x1
#define O_WRONLY		0x2
#define O_CREAT			0x0100
#define O_TRUNC			0x0200
#define O_APPEND		0x0800
#define O_BINARY		0x8000

#ifdef __cplusplus
extern "C" {
#endif

int __open(const char *filename, int mode);
int __close(int fd);
int __read(int fd, unsigned char *buf, int count);
int __write(int fd, const unsigned char *buf, int count);
long __lseek(int fd, long offset, int whence);
int __unlink(const char *filename);
int _Fwrite(FILE *stream, const unsigned char *buf, int count);
int _Fread(FILE *stream, unsigned char *buf, int count);

#ifdef __cplusplus
}
#endif

#if __MWERKS__
#pragma options align=reset
#endif

#endif
