/*
 *		CallKeyEquivalents.h:	defines that let you callback to CMaster and have it
 *								perform some keyboard equivalent for you
 *		Copyright  1994 Jersey Scientific, All Rights Reserved
 *
 *		History:
 *			06/12/94		original file shipped with CMaster 2.0
 *
 */
 */


#define MOVE_TO_TOP_OF_WINDOW              3 // Move To Top of Window
#define MOVE_TO_CURRENT_FUNCTION_TOP       4 // Move To Current Function Top
#define MOVE_TO_TOP_OF_FILE                5 // Move To Top of File
#define MOVE_CARET_TO_TOP_OF_WINDOW        6 // Move Caret to Top of Window
#define MOVE_TO_MIDDLE_OF_WINDOW          15 // Move To Middle of Window
#define MOVE_TO_CURRENT_FUNCTION_MIDDLE   16 // Move To Current Function Middle
#define MOVE_TO_MIDDLE_OF_FILE            17 // Move To Middle of File
#define MOVE_CARET_TO_MIDDLE_OF_WINDOW    18 // Move Caret to Middle of Window
#define MOVE_TO_BOTTOM_OF_SCREEN          27 // Move To Bottom of Screen
#define MOVE_TO_CURRENT_FUNCTION_END      28 // Move To Current Function End
#define MOVE_TO_END_OF_FILE               29 // Move To End of File
#define MOVE_CARET_TO_BOTTOM_OF_WINDOW    30 // Move Caret to Bottom of Window
#define SEARCH_FORWARD_dFILEb             39 // Search Forward (file)
#define SEARCH_FORWARD_dFUNCTIONb         40 // Search Forward (function)
#define SEARCH_FORWARD_dFILEj_ALT_WRAPb   41 // Search Forward (file, alt wrap)
#define SEARCH_FORWARD_WITH_TC_FIND_STR   42 // Search Forward With TC Find Str
#define SEARCH_BACKWARD_dFILEb            43 // Search Backward (file)
#define SEARCH_BACKWARD_dFUNCTIONb        44 // Search Backward (function)
#define SEARCH_BACKWARD_dFILEjALT_WRAPb   45 // Search Backward (file,alt wrap)
#define SEARCH_FORWARD_dFILEjWRAPjANYb    46 // Search Forward (file,wrap,any)
#define SEARCH_FOR_UNUSED___VARIABLES     47 // Search for unused  variables
#define SEARCH_BACKWARD_dFILEjWRAPjANYb   48 // Search Backward (file,wrap,any)
#define COMMENT_UNCOMMENT_SELECTION       51 // Comment/Uncomment Selection
#define ALT_COMMENT_UNCOMMENT_SELECTION   52 // Alt Comment/Uncomment Selection
#define pIFDEF__VARIABLE__SELECTION       53 // #ifdef <variable> Selection
#define COMMENT_SELECTION_WITH________    55 // Comment Selection with /*...*/
#define PASTE_CLIPBOARD_1                 63 // Paste Clipboard 1
#define PASTE_CLIPBOARD_1_dALTERNATEb     64 // Paste Clipboard 1 (alternate)
#define PASTE_CLIPBOARD_1_dRETAINb        65 // Paste Clipboard 1 (retain)
#define DELETE_CLIPBOARD_1                66 // Delete Clipboard 1
#define COPY_TO_CLIPBOARD_1               67 // Copy to Clipboard 1
#define COPY_TO_CLIPBOARD_1_dALTERNATEb   68 // Copy to Clipboard 1 (alternate)
#define APPEND_TO_THINK_S_CLIPBOARD       69 // Append to THINKs Clipboard
#define PASTE_CLIPBOARD_1_dALTj_RETAINb   70 // Paste Clipboard 1 (alt, retain)
#define DELETE_CLIPBOARD_1_dALTERNATEb    71 // Delete Clipboard 1 (alternate)
#define SWAP_LOCAL_n_GLOBAL_CLIPBOARD_1   72 // Swap Local & Global Clipboard 1
#define PASTE_CLIPBOARD_2                 75 // Paste Clipboard 2
#define PASTE_CLIPBOARD_2_dALTERNATEb     76 // Paste Clipboard 2 (alternate)
#define PASTE_CLIPBOARD_2_dRETAINb        77 // Paste Clipboard 2 (retain)
#define DELETE_CLIPBOARD_2                78 // Delete Clipboard 2
#define COPY_TO_CLIPBOARD_2               79 // Copy to Clipboard 2
#define COPY_TO_CLIPBOARD_2_dALTERNATEb   80 // Copy to Clipboard 2 (alternate)
#define PASTE_CLIPBOARD_2_dALTj_RETAINb   82 // Paste Clipboard 2 (alt, retain)
#define DELETE_CLIPBOARD_2_dALTERNATEb    83 // Delete Clipboard 2 (alternate)
#define SWAP_LOCAL_n_GLOBAL_CLIPBOARD_2   84 // Swap Local & Global Clipboard 2
#define PASTE_CLIPBOARD_3                 87 // Paste Clipboard 3
#define PASTE_CLIPBOARD_3_dALTERNATEb     88 // Paste Clipboard 3 (alternate)
#define PASTE_CLIPBOARD_3_dRETAINb        89 // Paste Clipboard 3 (retain)
#define DELETE_CLIPBOARD_3                90 // Delete Clipboard 3
#define COPY_TO_CLIPBOARD_3               91 // Copy to Clipboard 3
#define COPY_TO_CLIPBOARD_3_dALTERNATEb   92 // Copy to Clipboard 3 (alternate)
#define PASTE_CLIPBOARD_3_dALTj_RETAINb   94 // Paste Clipboard 3 (alt, retain)
#define DELETE_CLIPBOARD_3_dALTERNATEb    95 // Delete Clipboard 3 (alternate)
#define SWAP_LOCAL_n_GLOBAL_CLIPBOARD_3   96 // Swap Local & Global Clipboard 3
#define PASTE_CLIPBOARD_4                 99 // Paste Clipboard 4
#define PASTE_CLIPBOARD_4_dALTERNATEb    100 // Paste Clipboard 4 (alternate)
#define PASTE_CLIPBOARD_4_dRETAINb       101 // Paste Clipboard 4 (retain)
#define DELETE_CLIPBOARD_4               102 // Delete Clipboard 4
#define COPY_TO_CLIPBOARD_4              103 // Copy to Clipboard 4
#define COPY_TO_CLIPBOARD_4_dALTERNATEb  104 // Copy to Clipboard 4 (alternate)
#define PASTE_CLIPBOARD_4_dALTj_RETAINb  106 // Paste Clipboard 4 (alt, retain)
#define DELETE_CLIPBOARD_4_dALTERNATEb   107 // Delete Clipboard 4 (alternate)
#define SWAP_LOCAL_n_GLOBAL_CLIPBOARD_4  108 // Swap Local & Global Clipboard 4
#define GO_TO_PLACE_MARKER_1             111 // Go To Place Marker 1
#define DELETE_PLACE_MARKER_1            114 // Delete Place Marker 1
#define SET_PLACE_MARKER_1               115 // Set Place Marker 1
#define OVERWRITE_PLACE_MARKER_1         117 // Overwrite Place Marker 1
#define GO_TO_PLACE_MARKER_2             123 // Go To Place Marker 2
#define DELETE_PLACE_MARKER_2            126 // Delete Place Marker 2
#define SET_PLACE_MARKER_2               127 // Set Place Marker 2
#define OVERWRITE_PLACE_MARKER_2         129 // Overwrite Place Marker 2
#define GO_TO_PLACE_MARKER_3             135 // Go To Place Marker 3
#define DELETE_PLACE_MARKER_3            138 // Delete Place Marker 3
#define SET_PLACE_MARKER_3               139 // Set Place Marker 3
#define OVERWRITE_PLACE_MARKER_3         141 // Overwrite Place Marker 3
#define GO_TO_PLACE_MARKER_4             147 // Go To Place Marker 4
#define DELETE_PLACE_MARKER_4            150 // Delete Place Marker 4
#define SET_PLACE_MARKER_4               151 // Set Place Marker 4
#define OVERWRITE_PLACE_MARKER_4         153 // Overwrite Place Marker 4
#define PASTE_PROTOTYPEdSb               159 // Paste Prototype(s)
#define PASTE_PROTOTYPEdSb_dRETAINb      160 // Paste Prototype(s) (retain)
#define DELETE_PROTOTYPE_DATA            162 // Delete Prototype Data
#define CALCULATE_PROTOTYPEdSb           163 // Calculate Prototype(s)
#define CALCULATE_PROTOTYPEdSb_dAPPENDb  164 // Calculate Prototype(s) (append)
#define CALCULATE_PROTOTYPEdSbj_MEMBERS  165 // Calculate Prototype(s), members
#define CALCULATE_PROTOTYPESjNO_STATICS  166 // Calculate Prototypes,no statics
#define CALCULATE_STATIC_PROTOTYPES      167 // Calculate static Prototypes
#define FUNCTION_SCAN_FORWARD            171 // Function Scan Forward
#define pENDIF_SCAN_FORWARD              172 // #endif Scan Forward
#define FUNCTION_SCAN_FORWARD_dWRAPb     173 // Function Scan Forward (wrap)
#define JUMP_TO_SELECTED_FUNCTION        174 // Jump to Selected Function
#define FUNCTION_SCAN_BACKWARD           175 // Function Scan Backward
#define pIF____SCAN_BACKWARD             176 // #if... Scan Backward
#define FUNCTION_SCAN_BACKWARD_dWRAPb    177 // Function Scan Backward (wrap)
#define pEL____pENDIF_SCAN_FORWARD       178 // #el.../#endif Scan Forward
#define pIF____pEL____SCAN_BACKWARD      180 // #if.../#el... Scan Backward
#define GOBACK_BACKWARD_dFILEb           207 // GoBack Backward (file)
#define GOBACK_BACKWARD_dPROJb           208 // GoBack Backward (proj)
#define GOBACK_BACKWARD_dFILEjALT_WRAPb  209 // GoBack Backward (file,alt wrap)
#define GOBACK_NEWEST_POSITION_dPROJb    210 // GoBack Newest Position (proj)
#define GOBACK_FORWARD_dFILEb            211 // GoBack Forward (file)
#define GOBACK_FORWARD_dPROJb            212 // GoBack Forward (proj)
#define GOBACK_FORWARD_dFILEj_ALT_WRAPb  213 // GoBack Forward (file, alt wrap)
#define GOBACK_BACKWARD_dPROJjALT_WRAPb  214 // GoBack Backward (proj,alt wrap)
#define GOBACK_OLDEST_POSITION_dPROJb    215 // GoBack Oldest Position (proj)
#define GOBACK_FORWARD_dPROJj_ALT_WRAPb  216 // GoBack Forward (proj, alt wrap)
