/*
 *		CallKeyFunctions.h:	defines that let you callback to CMaster and have it
 *							perform some Key Function for you
 *		Copyright  1994 Jersey Scientific, All Rights Reserved
 *
 *		History:
 *			06/12/94		original file shipped with CMaster 2.0
 *
 */

#define LINEj_JOIN                         1 // line, join
#define LINEj_SPLIT                        2 // line, split
#define SELECT_WORD                        3 // select word
#define SELECT_C_WORD                      4 // select C word
#define SELECT_LINE                        5 // select line
#define CURSOR_FORWARDS                    6 // cursor forwards
#define CURSOR_BACKWARDS                   7 // cursor backwards
#define CURSOR_UP                          8 // cursor up
#define CURSOR_DOWN                        9 // cursor down
#define FORWARDS_ONE_WORD                 10 // forwards one word
#define BACKWARDS_ONE_WORD                11 // backwards one word
#define MOVE_TO_BEGINNING_OF_LINE         12 // move to beginning of line
#define MOVE_TO_END_OF_LINE               13 // move to end of line
#define BACKWARDS_ONE_PAGE                14 // backwards one page
#define FORWARDS_ONE_PAGE                 15 // forwards one page
#define CHARACTER_DELETEj_FORWARDS        16 // character delete, forwards
#define CHARACTER_DELETEj_BACKWARDS       17 // character delete, backwards
#define DELETE_NEXT_WORD                  18 // delete next word
#define DELETE_PREVIOUS_WORD              19 // delete previous word
#define CAPITALIZATIONj_INVERT            20 // capitalization, invert
#define REFRESH_SCREEN                    21 // refresh screen
#define COPY_FILE_NAME_TO_SCRAP           22 // copy file name to scrap
#define TAB                               23 // tab
#define SMARTINDENT                       24 // SmartIndent
#define CARRIAGE_RETURN                   25 // carriage return
#define SMARTRETURN                       26 // SmartReturn
#define SWAP_SCRAP_SELECTION              27 // swap scrap/selection
#define EXTEND_SELECTION_RIGHT_ONE_CHAR   28 // extend selection right one char
#define EXTEND_SELECTION_LEFT_ONE_CHAR    29 // extend selection left one char
#define DELETE_LINE_LEFT                  30 // delete line left
#define DELETE_LINE_RIGHT                 31 // delete line right
#define TRANSPOSE_TWO_CHARS               32 // transpose two chars
#define SWAP__C_n__H_WINDOWS              33 // swap .c & .h windows
#define KISS_MATCHING_CHAR                34 // kiss matching char
#define JUMP_TO_MATCHING_CHAR             35 // jump to matching char
#define SNAPBACKj_SET_THIS_POSITION       36 // SnapBack, set this position
#define MOVE_TO_INACTIVE_SPLIT_WINDOW     37 // move to inactive split window
#define MOVE_FORWARDS_TO_NEXT_WINDOW      38 // move forwards to next window
#define MOVE_BACKWARDS_TO_NEXT_WINDOW     39 // move backwards to next window
#define GOBACKj_SET_THIS_POSITION         40 // Goback, set this position
#define SCROLL_BACKWARDS_ONE_WINDOW       41 // scroll backwards one window
#define SCROLL_FORWARDS_ONE_WINDOW        42 // scroll forwards one window
#define THINK_REF___TEMPLATE_LOOKUP       43 // THINK Ref  template lookup
#define THINK_REF_LOOKUP_dSCREENb         44 // THINK Ref lookup (screen)
#define THINK_REF_LOOKUP_dUPTO__NOTES_b   45 // THINK Ref lookup (upto Notes)
#define THINK_REF_LOOKUP_dALLb            46 // THINK Ref lookup (all)
#define THINK_REFj_LOOKUP_THEN_GOTO       47 // THINK Ref, lookup then goto
#define BLOCK_INDENT_SELECTION_WITH___    48 // block indent selection with {}
#define DELETE_CURRENT_LINE               49 // delete current line
#define COMMAND_X_dCUTb_ALIAS             50 // Command-X (cut) alias
#define COMMAND_C_dCOPYb_ALIAS            51 // Command-C (copy) alias
#define COMMAND_V_dPASTEb_ALIAS           52 // Command-V (paste) alias
#define COMMAND_Z_dUNDOb_ALIAS            53 // Command-Z (undo) alias
#define BUILD____MENU_ALIAS               54 // Build... menu alias
#define EXTEND_SELECTION_TO_LINE_BEGIN    55 // extend selection to line begin
#define EXTEND_SELECTION_TO_LINE_END      56 // extend selection to line end
#define EXTEND_SELECTION_ONE_WORD_LEFT    57 // extend selection one word left
#define EXTEND_SELECTION_ONE_WORD_RIGHT   58 // extend selection one word right
#define EXTEND_SEL_TO_FULL_LINES          59 // extend sel to full lines
#define SMARTCOPY                         60 // SmartCopy
#define NEW_LINE_INSERT_WITH_INDENT       61 // new line insert with indent
#define NEW_LINE_INSERT_WITHOUT_INDENT    62 // new line insert without indent
#define NEW_LINE_APPEND_WITH_INDENT       63 // new line append with indent
#define NEW_LINE_APPEND_WITHOUT_INDENT    64 // new line append without indent
#define ADD_A_NEW_AUTOMATIC_VARIABLE      65 // add a new automatic variable
#define JUMP_TO_END_OF_AUTOMATIC_VARS     66 // jump to end of automatic vars
#define LOAD_THE_THINK_FIND_STRING        67 // load the THINK find string
#define LOAD_THE_THINK_REPLACE_STRING     68 // load the THINK replace string
#define SWAP_COMPARISON_ARGUEMENTS        69 // swap comparison arguements
#define PARENTHESIZE_SELECTION            70 // parenthesize selection
#define COPY_FILE_PATH:NAME_TO_SCRAP      71 // copy file path:name to scrap
#define SIZE_WINDOW_TO_SPECIFIED_WIDTH    72 // size window to specified width
#define SIZE_WINDOW_TO_SPECIFIED_HEIGHT   73 // size window to specified height
#define SIZE_WINDOW_TO_SPECIFIED_H_n_W    74 // size window to specified h & w
#define CAPITALIZATIONj_FORCE_UPPER       75 // capitalization, force upper
#define CAPITALIZATIONj_FORCE_LOWER       76 // capitalization, force lower
#define SORT_LINESj_ALPHABETICj_CASE      77 // sort lines, alphabetic, case
#define SORT_LINESj_ALPHABETICj_NOCASE    78 // sort lines, alphabetic, nocase
#define SORT_LINESj_BY_LENGTH             79 // sort lines, by length
#define SORT_LINESj_NUMERIC               80 // sort lines, numeric
#define SORT_LINESj_REVERSE_ORDER         81 // sort lines, reverse order
#define OPEN__ALIASED_PRECOMP_SRC_FILE_   82 // open Aliased PreComp Src File
#define TAB_TO__TABS_TO_COMMENT_jADD_C    83 // tab to Tabs To Comment,add /*
#define TAB_TO__TABS_TO_COMMENT_jADD_CP   84 // tab to Tabs To Comment,add //
#define MATCH_PREV_STR_n_PASTEj_f_BK      85 // match prev str & paste,  <-
#define MATCH_PREV_STR_n_PASTEj_f_FW      86 // match prev str & paste,  ->
#define MATCH_PREV_STR_n_PASTEj_FILE_BK   87 // match prev str & paste, File <-
#define MATCH_PREV_STR_n_PASTEj_FILE_FW   88 // match prev str & paste, File ->
#define SMARTPASTE                        89 // SmartPaste
#define SOUNDj_DONEBEEPdb                 90 // sound, DoneBeep()
#define SOUNDj_SOFTBEEPdb                 91 // sound, SoftBeep()
#define SOUNDj_HARDBEEPdb                 92 // sound, HardBeep()
#define XTRNSj_FORCE_A_TOTAL_REBUILD      93 // XTRNs, force a total rebuild
#define XTRNSj_FORCE_A_DATE_SEARCH        94 // XTRNs, force a date search
#define XTRNSj_DELETE_ALL_RESOURCES       95 // XTRNs, delete all resources
#define SET_CMASTER_FIND_STRING           96 // set CMaster find string
#define GLOSSARYj_FIND_AND_HILITE_NEXT    97 // glossary, find and hilite next
#define MACROj_STOP_RECORDING             98 // Macro, stop recording
#define SCRIPTj_SEND_SEL_AND_PASTE_RESP   99 // script, send sel and paste resp
#define TOOLSERVERj_SEND_SEL_PASTE_RESP  100 // ToolServer, send sel/paste resp
#define TEXT_FILEj_READ_THEN_PASTE       101 // text file, read then paste
#define FIND_STRINGj_CMASTER__THINK      102 // find string, CMaster->THINK
#define FILEj_LOCK                       103 // file, lock
#define FILEj_UNLOCK                     104 // file, unlock
#define APPEND_SELECTION_TO_THINK_SCRAP  105 // append selection to THINK scrap
#define MOVE_WINDOW_TO_WIND_TEMPLATE     106 // move window to WIND template
