/**************************************************************************

	CWFailure.h
	
	Mark E. Anderson
	8/8/94

CW currently can't output to stderr.  What follows is a kludge that puts the message 
in a window of the Scriptable Text Editor through AppleScript.
You *must* open Scriptable Text Editor for this code to work.
	
**************************************************************************/
#ifndef __CWFAILURE__
#define __CWFAILURE__


#if __MWERKS__  && qDebug

#ifndef __APPLEEVENTS__
#include <AppleEvents.h>
#endif

#ifndef __AEREGISTRY__
#include <AERegistry.h>
#endif

#ifndef __AEOBJECTS__
#include <AEObjects.h>
#endif

#ifndef __AEOBJECTPACKING__
#include <AEPackObject.h>
#endif

#ifndef _STDARG
#include <stdarg.h>
#endif

#ifndef __FCNTL__
#include <FCntl.h>
#endif

#ifndef __GESTALTEQU__
#include <GestaltEqu.h>
#endif


class XAEApplication {
protected:
	AEDesc		fAppObj;
public:
	XAEApplication( void );
	~XAEApplication( void );
	virtual AEDesc * GetObject(void) { return &fAppObj; }
	
};


class XAEWindow : public XAEApplication {
protected:
	AEDesc		fWindObj;
public:

	XAEWindow( void );
	~XAEWindow( void );
	virtual AEDesc * GetObject(void) { return &fWindObj; }
	
};


class XAEParagraph : public XAEWindow {

protected:
	AEDesc		fParaObj;
public:
	XAEParagraph() { ProgramBreak("XAEParagraph called without parameters");}
	XAEParagraph(  long windowNumber );
	~XAEParagraph( void );
	virtual AEDesc * GetObject(void) { return &fParaObj; }
	
};

class XAppleEvent	{
	AppleEvent 		fEvent;
public:
	XAppleEvent() { ProgramBreak("XAppleEvent called without parameters");}
	XAppleEvent( OSType appid, OSType eventclass, OSType eventid );
	XAppleEvent( OSType appid, OSType eventclass, OSType eventid, XAEApplication* directObject );
	OSErr	AddIndirectObject( AEKeyword theKeyword, DescType type, Ptr thing, Size size );
	OSErr 	Send();
	OSErr	GetResponseFromReply( OSType desiredType, Ptr thing, Size size );
	long	GetNumOfThings( void );
	Boolean	DoesThingExist( void );
	~XAppleEvent(void);	
};

//constants
const	long	badReturnValue = -1L;

//prototypes
Boolean sendMessageToWrite (OSType appid, OSType eventclass, OSType eventid, char * tmp) ;
Boolean FindAProcess( OSType signature );
Boolean AppleEventsAvailable( void );


#endif
#endif
