#	File MakeFile -  Make instructions for C examples.
#
#	Copyright Apple Computer, Inc. 1986-1994
#	All rights reserved.
#
#	This makefile builds:
#		The sample C tool:				Count

# 	You can define {SymOptions} as "-sym on" or "-sym off" for use with SADE
# 	We also recommend requiring prototypes for all functions

VERSION	= 3.4d2
OBJECTS = Count.c.o


SymOptions	=	-sym Full
SymOpt		=	{SymOptions}
COptions	=	-r -opt off {SymOpt} -mbg full -mc68020
# Must use the MPW CIncludes not Metrowerks, make '\n' work correctly for mpw
PPCC		=	MWCPPC
PPCCOptions	=	{SymOpt} -I "{CIncludes}"
PPCLink		=	MWLinkPPC


.c.x		.c
	{PPCC} {Default}.c -o {Default}.c.x {PPCCOptions}

#######################################################################
# Build instructions and dependencies for the Count tool
#

Count			Count.c.x
	{PPCLink} Count.c.x {SymOpt} -ft MPST -fc 'MPS ' 
		"{MWPPCLibraries}"MWStdCRuntime.Lib 
		"{MWPPCLibraries}"StdCLib 
		"{MWPPCLibraries}"InterfaceLib 
		"{PPCLibraries}"PPCToolLibs.o 
		 -o {Targ}
	SetFile -m . -c . {Targ}

Count			Count.rsrc
	Echo "include "{NewerDeps}";" | Rez -append -o {Targ} -t MPST -c 'MPS '
	SetFile -m . -c . {Targ}

Count			Count.Make
	SetVersion -t 'vers' -i 1 -version "{VERSION}" {Targ}
	SetFile -m . -d . -t MPST -c 'MPS ' {Targ}

#######################################################################

Count.rsrc		Count.r GenericCFRG.r
	Rez {NewerDeps} -o Count.rsrc -append -d APPNAME="Count" -c 'RSED' -t rsrc

Count.rsrc	 {OBJECTS}
	Link -d -c 'RSED' -t rsrc {SymOpt} -mf 
		{OBJECTS} 
		"{CLibraries}"StdClib.o 
		"{Libraries}"Stubs.o 
		"{Libraries}"Runtime.o 
		"{Libraries}"Interface.o 
		"{Libraries}"ToolLibs.o 
		"{Libraries}"IntEnv.o 
		-o Count.rsrc
