#ifndef __Assembler__
#define __Assembler__

#ifndef __TRAPS__
#include <Traps.h>
#endif

#define immed			0x0200
#define clear			0x0200
#define aSync			0x0400
#define sys 			0x0400
#define autoPop 		0x0400
#define marks			0x0200
#define caseSensitive	0x0400
// BBFix #define caseSens	0x0400
// BBFix Changed caseSens to caseSensitive to avoid a conflict with Universal Headers TextUtils.h file
#define newToolTrap 	0x0600
#define newOSTrap		0x0200

/* High level file system services */
#define _FSControl				OP	0x7000,0xA260
#define _OpenWD					OP	0x7001,0xA260
#define _CloseWD				OP	0x7002,0xA260
#define _CatMove				OP	0x7005,0xA260
#define _DirCreate				OP	0x7006,0xA260
#define _GetWDInfo				OP	0x7007,0xA260
#define _GetFCBInfo				OP	0x7008,0xA260
#define _GetCatInfo				OP	0x7009,0xA260
#define _SetCatInfo				OP	0x700A,0xA260
#define _SetVolInfo				OP	0x700B,0xA260
#define _SetPMSP				OP	0x700C,0xA260
#define _LockRng				OP	0x7010,0xA260
#define _UnlockRng				OP	0x7011,0xA260
#define _CreateFileIDRef		OP	0x7014,0xA260
#define _DeleteFileIDRef		OP	0x7015,0xA260
#define _ResolveFileIDRef		OP	0x7016,0xA260
#define _ExchangeFiles			OP	0x7017,0xA260
#define _CatSearch				OP	0x7018,0xA260
#define _OpenDF					OP	0x701A,0xA060
#define _HOpenDF				OP	0x701A,0xA260
#define _MakeFSSpec				OP	0x701B,0xA260
#define _DTGetPath				OP	0x7020,0xA260
#define _DTCloseDown			OP	0x7021,0xA260
#define _DTAddIcon				OP	0x7022,0xA260
#define _DTGetIcon				OP	0x7023,0xA260
#define _DTGetIconInfo			OP	0x7024,0xA260
#define _DTAddAPPL				OP	0x7025,0xA260
#define _DTRemoveAPPL			OP	0x7026,0xA260
#define _DTGetAPPL				OP	0x7027,0xA260
#define _DTSetComment			OP	0x7028,0xA260
#define _DTRemoveComment		OP	0x7029,0xA260
#define _DTGetComment			OP	0x702A,0xA260
#define _DTFlush				OP	0x702B,0xA260
#define _DTReset				OP	0x702C,0xA260
#define _DTGetInfo				OP	0x702D,0xA260
#define _DTOpenInform			OP	0x702E,0xA260
#define _DTDelete				OP	0x702F,0xA260
#define _GetVolParms			OP	0x7030,0xA260
#define _GetLogInInfo			OP	0x7031,0xA260
#define _GetDirAccess			OP	0x7032,0xA260
#define _SetDirAccess			OP	0x7033,0xA260
#define _MapID					OP	0x7034,0xA260
#define _MapName				OP	0x7035,0xA260
#define _CopyFile				OP	0x7036,0xA260
#define _MoveRename				OP	0x7037,0xA260
#define _OpenDeny				OP	0x7038,0xA260
#define _OpenRFDeny				OP	0x7039,0xA260
#define _GetVolMountInfoSize	OP	0x703F,0xA260
#define _GetVolMountInfo		OP	0x7040,0xA260
#define _VolumeMount			OP	0x7041,0xA260
#define _GetForeignPrivs		OP	0x7060,0xA260
#define _SetForeignPrivs		OP	0x7061,0xA260

/* MultiFinder traps 0x3F3C := MOVE.W #XXXX,-(sp) */
#define _MFMaxMem				OP	0x3F3C,21,0xA88F
#define _MFFreeMem				OP	0x3F3C,24,0xA88F
#define _MFTempNewHandle		OP	0x3F3C,29,0xA88F
#define _MFTempHLock			OP	0x3F3C,30,0xA88F
#define _MFTempHUnlock			OP	0x3F3C,31,0xA88F
#define _MFTempDisposHandle		OP	0x3F3C,32,0xA88F

#define _GetTimeOut					MOVEA.W %0,A0; _InternalWait
#define _SetTimeOut					MOVEA.W %1,A0; _InternalWait

/* HwPriv Trap */
#define _DisableInstructionCache	moveq %0,d0; movea.l d0,a0; _HWPriv
#define _EnableInstructionCache		moveq %0,d0; movea.w %1,a0; _HWPriv
#define _FlushInstructionCache		moveq %1,d0; _HWPriv
#define _DisableDataCache			moveq %2,d0; movea.w %0,a0; _HWPriv
#define _EnableDataCache			moveq %2,d0; movea.l d0,a0; _HWPriv
#define _FlushDataCache				moveq %3,d0; _HWPriv

#define _NewGWorld				OP	0x7000,0xAB1D
#define _LockPixels				OP	0x7001,0xAB1D
#define _UnlockPixels			OP	0x7002,0xAB1D
#define _UpdateGWorld			OP	0x7003,0xAB1D
#define _DisposeGWorld			OP	0x7004,0xAB1D
#define _GetGWorld				OP	0x7005,0xAB1D
#define _SetGWorld				OP	0x7006,0xAB1D
#define _CTabChanged			OP	0x7007,0xAB1D
#define _PixPatChanged			OP	0x7008,0xAB1D
#define _PortChanged			OP	0x7009,0xAB1D
#define _GDeviceChanged			OP	0x700A,0xAB1D
#define _AllowPurgePixels		OP	0x700B,0xAB1D
#define _NoPurgePixels			OP	0x700C,0xAB1D
#define _GetPixelsState			OP	0x700D,0xAB1D
#define _SetPixelsState			OP	0x700E,0xAB1D
#define _GetPixBaseAddr			OP	0x700F,0xAB1D
#define _NewScreenBuffer		OP	0x7010,0xAB1D
#define _DisposeScreenBuffer	OP	0x7011,0xAB1D
#define _GetGWorldDevice		OP	0x7012,0xAB1D

#define _SysBreak				MOVE.W %-490,D0; _SysError
#define _SysBreakStr			MOVE.W %-491,D0; _SysError
#define _SysBreakFunc			MOVE.W %-492,D0; _SysError

#endif
