/****
 * CLaughsDoc.cp
 *
 *	Declaration of a document class full of laughs.
 *
 *  Copyright  1994 NeoLogic Systems.  All rights reserved.
 *
 *	NOTE: This sample application uses the SIOUX serial i/o emulator for outputing
 *	text using printf. There are a number of bugs in this mechanism which causes
 *	rather unusual behavior.
 *
 *	The window can't be moved on the screen. SIOUX ignores mouse clicks directed
 *	to the window.
 *
 *	The Save menu item saves the text in the window NOT the NeoAccess database
 *	that this application uses.
 *
 *	In order to quit the application must choose quit twice.
 *
 ****/
#pragma once			/* Include this file only once */

#include CNeoDocRootH

const OSType kLaughsFileType	= 'Ne6d';

class CLaughsDoc : public CNeoDocRoot {
public:
						CLaughsDoc(const Boolean aPrintable, const Boolean aNewDatabase, const Boolean aRemote);

	virtual void		buildWindow(void);
	virtual void		newDatabase(void);
	virtual void		openFile(FSSpec *aSpec);

	void				createObjects(void);
	void				printOut(void);
};