/****
 * CNeoBenchPane.h
 *
 *	Pane class for a typical application.
 *
 ****/

#define _H_CNeoBenchPane			/* Include this file only once */
#include <CPane.h>
#include <CButton.h>
#include "NeoBench.h"

class  CRawText;
class  CIntegerText;

// Constants relating to resources

#define cmdSTOP		1000
#define cmdGO		1001

struct CNeoBenchPane : CPane {

	CRawText	*NeoRawTexts[kMaxPhase +1][kMaxCol +1];	// the texts displaying the numbers
	CIntegerText*NeoEditTexts[kMaxPhase +1];			// the TOTALS editable texts
	CRawText	*NeoStatsAcross[kMaxCol +1];			// Column names
	CRawText	*NeoPhaseNames[kMaxPhase +1];			// Phase names
	CButton		*NeoStopButton;							// Stop button
	CButton		*NeoGoButton;							// Go button

	long		maxValue[kMaxPhase +1];
	long		minValue[kMaxPhase +1];

									/** Contruction/Destruction **/
	void		INeoBenchPane(CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing, SizingOption aVSizing);

									/** Drawing **/
	void		Draw(Rect *area);

									/** Mouse **/
	void		DoClick(Point hitPt, short modifierKeys, long when);
	Boolean		HitSamePart(Point pointA, Point pointB);

									/** Cursor **/
	void		AdjustCursor(Point where, RgnHandle mouseRgn);
									/** Scrolling **/

	long		GetTotalNum(short index);
	void		ClearStatPanes(void);
	void		DoKeyDown(char theChar, Byte keyCode, EventRecord *macEvent);
	void		DoCommand(long	theCommand);
	void		UpdateCol(short aPhase, short aRow, long aValue);
};
