/****
 * CNeoBenchDoc.h
 *
 *	Document class for a typical application.
 *
 ****/

#ifndef _H_NeoBench
#define	_H_NeoBench			/* Include this file only once */
#include <time.h>

/*
 * A NeoPhase structure,  containing a target string,
 * number of iterations done,  and a soFar in milliseconds.
 */

enum phases {
	kNoPhase	= -1,
	kMinPhase	= 0,
	kInsert		= kMinPhase,
	kRandomly,
	kSerially,
	kChange,
	kDelete,
	kMaxPhase	= kDelete
};

// Indices into the array going across.  There are three of them
enum cols {
	kMinCol		= 0,
	kTargetCol	= kMinCol,
	kSoFar,
	kPerRecord,
	kTotal,
	kMaxCol		= kTotal
};

enum states {
	kStop,
	kStart
};

typedef struct NeoPhase {
	Boolean	dirty;		/* Do values for this phase need updating?	*/
#ifdef qNeoThreads
	short	threadCount;/* Number of threads to use for this phase	*/
#endif
	long	target;		/* Copied from TextBox field in main pane   */
	long	delta;		/* Initial count */
	long	done;		/* Number of operations done so far			*/
	long	committed;	/* Number of operations done so far			*/
	long	soFar;		/* Total time units in Milliseconds so far	*/
} NeoPhase;

#define k30MicroMinutes		-(1800000000L)

extern long gLoopOverhead;	// Timer Manager Overhead

#endif
