/******************************************************************************
 CDLOGDialog.h

		Interface for DLOGDialog class.

	SUPERCLASS = CDialog

	Copyright  1991 Symantec Corporation. All rights reserved.
	Copyright  1992 NeoLogic Systems.  All rights reserved.


 ******************************************************************************/

#ifndef __CNEODLOGDIALOG__
#define __CNEODLOGDIALOG__

#include <CDialog.h>

class CNeoPopupPane;
class CDirector;

class CNeoDLOGDialog : public CDialog
{
public:
						CNeoDLOGDialog(short DLOGid, CDesktop *anEnclosure, CDirector *aSupervisor);
	virtual				~CNeoDLOGDialog(void);
	void				DoKeyDown(char theChar, Byte keyCode, EventRecord *macEvent);
	Boolean				isZoomed(void);
	short				NeoDLOGGetType(void);		/* return popup selection index */
	virtual void		Update(void);

protected:
	short				fStaticTextFont;			/* default font to use for static text items	*/
	short				fStaticTextSize;			/* default size to use for static text items	*/
	short				fEditTextFont;				/* default font for edit text items				*/
	short				fEditTextSize;				/* default size for edit text items				*/
	short				fDefaultBorderPen;			/* default border thickness for user items		*/
													/* and RadioGroupPanes							*/

	virtual void		AddDITLItems(short DITLid, long baseID);
	virtual CPane *		AddDITLPushBtn(short aWidth, short aHeight, short hEncl, short vEncl, CView *enclosure, tDITLItem *ditlItem);
	virtual CPane *		AddDITLRadioBtn(short aWidth, short aHeight, short hEncl, short vEncl, CView *enclosure, tDITLItem *ditlItem, long anID);
	virtual CPane *		AddDITLCheckBox(short aWidth, short aHeight, short hEncl, short vEncl, CView *enclosure, tDITLItem *ditlItem);
	virtual CPane *		AddDITLResControl(short aWidth, short aHeight, short hEncl, short vEncl, CView *enclosure, tDITLItem *ditlItem);
	virtual CPane *		AddDITLStatText(short aWidth, short aHeight, short hEncl, short vEncl, CView *enclosure, tDITLItem *ditlItem);
	virtual CPane *		AddDITLEditText(short aWidth, short aHeight, short hEncl, short vEncl, CView *enclosure, tDITLItem *ditlItem);
	virtual CPane *		AddDITLIcon(short aWidth, short aHeight, short hEncl, short vEncl, CView *enclosure, tDITLItem *ditlItem);
	virtual CPane *		AddDITLPicture(short aWidth, short aHeight, short hEncl, short vEncl, CView *enclosure, tDITLItem *ditlItem);
	virtual CPane *		AddDITLUserItem(short aWidth, short aHeight, short hEncl, short vEncl, CView *enclosure, tDITLItem *ditlItem);
	virtual CPane *		AddOverloadedItem(StringPtr itemText, short aWidth, short aHeight, short hEncl, short vEncl, CView *enclosure, tDITLItem *ditlItem);
	virtual CView *		FindEnclosingView(Rect *boundsRect);
	CNeoPopupPane *		makePopup(short aID, CView *aEnclosure, short aWidth, short aHeight, short aHEncl, short aVEncl, short aSpace);
	virtual void 		ProviderChanged(CCollaborator *aProvider, long reason, void* info);
			void		DoCommand(long	theCommand);
};
#endif