/****
 * CNeoDemoDoc.h
 *
 *	Document class for a typical application.
 *  Copyright  1992 NeoLogic Systems.  All rights reserved.
 *
 ****/

#define	_H_CNeoDemoDoc			/* Include this file only once */
#include CNeoDocRootH

class CNeoPopupPane;
class CNDFilePicture;
class CNeoDemoScrollPane;
class CNeoDialogText;
class CEditText;
class CNDPicture;
class CNDImage;
class CNeoKeywordSelect;

enum{
	kNDImagePICT=1,
	kNDImageTIFF,
	kNDImageGIF,
	kNDImage
};   /* item indices in type popup */

struct CNeoDemoDoc : public CNeoDocRoot {
public:

						// Instance Methods
    	        		CNeoDemoDoc(CApplication *aSupervisor, const Boolean printable, const Boolean aNewFile, const Boolean aRemote);
	virtual				~CNeoDemoDoc(void);

	virtual void		buildWindow(void);
	virtual Boolean		DoSave(void);
 	virtual void		NewFile(void);
	virtual void		OpenFile(SFReply *macSFReply);
	virtual void        UpdateMenus(void);
	virtual void		Zoom(Boolean aOut);

	void				buildCameraMenu(void);
	void				buildShutterMenu(const NeoID aCameraID);
	Boolean				doCutCopy(const Boolean aCut);
	Boolean				doPaste(void);
	void				emptyImageArray(void);
	NeoID				getCameraID(void);
	CNDImage *			getImage(const short aIndex);	/* return image from fImageArray at fIndex */
	short				getImageCount(void);
	short				getImageType(void);
	CNeoKeywordSelect *	getKeywordKey(char *aKey);
	void 				gotoImage(short index, const Boolean aRedraw);
	void				removeImage(const short aIndex);
	void				setCameraID(const NeoID aID);
	void				setImageDirty(CCollaborator *aProvider, void* info, const Boolean aMenu);
	void				setItems(CNDImage *aImage);
	short				setSelectionByID(const NeoID aClassID, const NeoID aID);
	short				setSelectionByKeyword(const NeoID aBaseClassID, char *aKey);
	void				showBorders(const Boolean aShow);
	void 				updateImage(CNDImage *aImage);


	short				fDivideLine;				/* Y coord for cutting off lower fields */
	short				fBottomLine;				/* original Y coord includes all fields */
	short				fIndex;						/* index into fImageArray for current image object */
	CArray *			fImageArray;				/* array of image objects to scroll through */
	CNeoKeywordSelect *	fSelectKey;					/* current keyword select key */
	CNDFilePicture *	fPictObj;					/* need to set its picture handle on scroll */
	CNeoDemoScrollPane *fScrollObj; 				/* need to reset maximum as items are cut/pasted */
	CNeoDialogText *	fTextName;					/* name of the picture */
	CEditText *			fTextInfo;					/* object which displays <pict#>/<max#> */
	CEditText *			fTextType;					/* displays the current type */
	CNeoDialogText *	fTextBy;					/* save text to the CNDImage type object */
	CNeoDialogText *	fTextDate;
	CNeoDialogText *	fTextCatalog;
	CNeoDialogText *	fTextKeywords;				/* parse strings into 'fkey' array */
	CNeoPopupPane *		fPopObj;					/* checked item is the type to find */
	CNeoPopupPane *		fPopFilm;					/* save selected item number to image type object */
	CNeoPopupPane *		fPopBody;
	CNeoPopupPane *		fPopFocal;
	CNeoPopupPane *		fPopFStop;
	CNeoPopupPane *		fPopExposure;
	CNDPicture *		fSignal;
	CNeoDialogText *	fSearchText;				/* text used in search */
};