/****
 * CNeoDemoDoc.h
 *
 *	Document class for a typical application.
 *  Copyright  1992 NeoLogic Systems.  All rights reserved.
 *
 ****/

#define	_H_NeoDemo			/* Include this file only once */
#include <time.h>

/*
 * A NeoPhase structure,  containing a target string,
 * number of iterations done,  and a SoFar in milliseconds.
 */

enum phases {
	kNoPhase	= -1,
	kMinPhase	= 0,
	kInsert		= kMinPhase,
	kRandomly,
	kSerially,
	kChange,
	kDelete,
	kMaxPhase	= kDelete
};

// Indices into the array going across.  There are three of them
enum cols {
	kMinCol		= 0,
	kTargetCol	= kMinCol,
	kSoFar,
	kPerRecord,
	kTotal,
	kMaxCol		= kTotal
};

enum states {
	kStop,
	kStart
};

typedef struct NeoPhase {
	long	target;		/* Copied from TextBox field in main pane   */
	long	done;		/* Number of operations done so far			*/
	long	SoFar;		/* Total time units in Milliseconds so far	*/
} NeoPhase;

