#pragma once

/* window variation codes (var code 1 isn't used since system would think
	it's a modal dialog) */
#define kWindoidDragTop				(0)	/* drag region above window */
#define kWindoidDragLeft			(2)	/* drag region to left of window */
#define kWindoidDragNone			(3)	/* no drag region */
#define kWindoidGrow					(4)	/* grow box */
#define kWindoidZoom					(8)	/* zoom box */

/* sizes of various items (in pixels) */
#define kWindoidBorderSize			(1)	/* width of border around window */
#define kWindoidShadowSize			(1)	/* width of shadow */
#define kWindoidDragSize			(9)	/* height or width of drag bar */
#define kWindoidGrowSize			(10)	/* size of grow box */
#define kWindoidGoAwaySize			(7)	/* size of close box */
#define kWindoidZoomSize			(7)	/* size of zoom box */
#define kWindoidZoomMargin			(7)	/* delta to ignore in zoom state */

/* macros for testing variation code */
#define WindoidDrag(var)			(((var) & 0x03) != kWindoidDragNone)
#define WindoidDragNone(var)		(((var) & 0x03) == kWindoidDragNone)
#define WindoidDragLeft(var)		(((var) & 0x03) == kWindoidDragLeft)
#define WindoidDragTop(var)		(((var) & 0x03) == kWindoidDragTop)
#define WindoidGrow(var)			(((var) & kWindoidGrow) && WindoidDrag(var))
#define WindoidZoom(var)			(((var) & kWindoidZoom) && WindoidDrag(var))

#define WindoidHasDrag(window)	WindoidDrag(GetWVariant(window))
#define WindoidHasGrow(window)	WindoidGrow(GetWVariant(window))
#define WindoidHasZoom(window)	WindoidZoom(GetWVariant(window))
