/**********************************************************************\

File:		kant.c

Purpose:	This module handles program initialization/shutdown.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "kant.h"
#include "kant main window.h"
#include "kant load-save.h"
#include "kant text twiddling.h"
#include "graphics.h"
#include "file interface.h"
#include "error.h"
#include "dialogs.h"
#include "program globals.h"

Boolean			gAlwaysResolve;
short			gSpeedDelay;

void InitTheProgram(void)
{
	SetIndDispatchProc(kMainWindow, MainWindowDispatch);
	CallIndDispatchProc(kMainWindow, kStartup, 0L);
}

void ShutDownTheProgram(void)
{
	CallIndDispatchProc(kMainWindow, kShutdown, 0L);
}

void Kantinuous(void)
{
	unsigned char	*sectionStr="\p&section\r&section\r&section\r";
	long			len;
	
	if (IndWindowExistsQQ(kMainWindow))
		CloseTheIndWindow(kMainWindow);
	OpenTheIndWindow(kMainWindow);
	len=sectionStr[0];
	TEInsert(&sectionStr[1], len, GetTheTextHandle());
	while (ParserDispatch((WindowDataHandle)GetWindowDataHandle(kMainWindow))==kNoError)
	{
		CloseTheIndWindow(kMainWindow);
		OpenTheIndWindow(kMainWindow);
		len=sectionStr[0];
		TEInsert(&sectionStr[1], len, GetTheTextHandle());
	}
}
