#include "menus.h"
#include "graphics.h"
#include "help.h"
#include "environment.h"
#include "print meat.h"
#include "program globals.h"
#include "kant main window.h"
#include "kant load-save.h"
#include "kant text twiddling.h"
//#include "kant search.h"
#include "kant.h"

static	MenuHandle		gAppleMenu;
static	MenuHandle		gFileMenu;
static	MenuHandle		gEditMenu;
static	MenuHandle		gOptionsMenu;
static	MenuHandle		gInsertMenu;
//static	MenuHandle		gFindMenu;
static	MenuHandle		gSpeedMenu;
static	Boolean			gMenuEnabled;

enum
{
	speedMenu = 200,
	
	appleMenu = 400, fileMenu, editMenu, optionsMenu, insertMenu, findMenu,
	
	aboutItem = 1, aboutMSGItem, helpPointerItem,
	
	newItem = 1, openItem, file_unused1, closeItem, saveItem, saveAsItem, file_unused2,
		pageSetupItem, printItem, file_unused3, quitItem,
	
	undoItem = 1, edit_unused1, cutItem, copyItem, pasteItem, clearItem, edit_unused2,
		selectAllItem,
	
	resolveItem = 1, alwaysResolveItem, option_unused1, option_unused2, option_unused3,
		kantinuousItem,
	
	sectionItem = 1, paragraphItem, sentenceItem, mainClauseItem, introClauseItem,
		throwawayClauseItem, proofItem, throwawaySentenceItem,
	
//	findItem = 1, findAgainItem, enterSelectionItem, replaceItem, replaceAndNextItem,
//		findSelectionItem,
	
	delay0Item = 1, delay6Item, delay12Item, delay30Item, delay60Item
};

/*-----------------------------------------------------------------------------------*/
/* internal stuff for menus.c                                                        */

static	void HandleAppleMenu(short menuItem);
static	void HandleFileMenu(short menuItem);
static	void HandleEditMenu(short menuItem);
static	void HandleHelpMenu(void);
static	void HandleOptionsMenu(short menuItem);
static	void HandleInsertMenu(short menuItem);
//static	void HandleFindMenu(short menuItem);
static	void HandleSpeedMenu(short menuItem);

Boolean InitTheMenus(void)
{
	Handle			MBARHandle;
	
	if ((MBARHandle=GetNewMBar(400))==0L)		/* sez which menus are in menu bar. */
		return FALSE;
	SetMenuBar(MBARHandle);						/* set this to be THE menu bar to use. */
	
	if ((gAppleMenu=GetMHandle(appleMenu))==0L)	/* GetNewMBar also got menu handles of */
		return FALSE;
	if ((gFileMenu=GetMHandle(fileMenu))==0L)	/* every menu it includes, so just */
		return FALSE;
	if ((gEditMenu=GetMHandle(editMenu))==0L)	/* grab these handles and assign them */
		return FALSE;
	if ((gOptionsMenu=GetMHandle(optionsMenu))==0L)
		return FALSE;
	if ((gInsertMenu=GetMHandle(insertMenu))==0L)
		return FALSE;
//	if ((gFindMenu=GetMHandle(findMenu))==0L)
//		return FALSE;
	if ((gSpeedMenu=GetMenu(speedMenu))==0L)
		return FALSE;
	
	InsertMenu(gSpeedMenu, -1);
	
	AddResMenu(gAppleMenu, 'DRVR');				/* adds control panels to apple menu */
	
	AdjustMenus();								/* dim/enable/check/mark menus/items */
	DrawMenuBar();								/* draws the actual menu bar */
	
	return TRUE;
}

void AdjustMenus(void)
{
	WindowPeek		theWindow;
	short			kind;
	long			dummy;
	
	if (gInProgress)
	{
		DisableItem(gAppleMenu, aboutItem);
		DisableItem(gAppleMenu, aboutMSGItem);
		DisableItem(gAppleMenu, helpPointerItem);
		DisableItem(gFileMenu, 0);
		DisableItem(gEditMenu, 0);
		DisableItem(gOptionsMenu, 0);
//		DisableItem(gFindMenu, 0);
		DisableItem(gInsertMenu, 0);
	}
	else
	{
		EnableItem(gAppleMenu, aboutItem);
		EnableItem(gAppleMenu, aboutMSGItem);
		EnableItem(gAppleMenu, helpPointerItem);
		EnableItem(gFileMenu, 0);
		EnableItem(gEditMenu, 0);
//		EnableItem(gFindMenu, 0);
		EnableItem(gOptionsMenu, 0);
		
		theWindow = (WindowPeek)FrontWindow();
		kind = theWindow ? theWindow->windowKind : 0;
		
		if ((kind < 0) ||
			((theWindow!=0L) && (theWindow==(WindowPeek)GetIndWindowPtr(kMainWindow))))
		{
			EnableItem(gEditMenu, 0);
		}
		else
		{
			DisableItem(gEditMenu, 0);
		}
		
		if (theWindow)
			EnableItem(gFileMenu, closeItem);
		else
			DisableItem(gFileMenu, closeItem);
		
		if (GetIndWindowPtr(kMainWindow))
		{
			DisableItem(gFileMenu, newItem);
			DisableItem(gFileMenu, openItem);
			EnableItem(gFileMenu, saveItem);
			EnableItem(gFileMenu, saveAsItem);
			EnableItem(gFileMenu, printItem);
			EnableItem(gOptionsMenu, resolveItem);
			
			EnableItem(gInsertMenu, 0);
			LoadScrap();
			if (GetScrap(0L, 'TEXT', &dummy)==noTypeErr)
				DisableItem(gEditMenu, pasteItem);
			else
				EnableItem(gEditMenu, pasteItem);
			
			if (AnyHighlightedQQ())
			{
				EnableItem(gEditMenu, cutItem);
				EnableItem(gEditMenu, copyItem);
				EnableItem(gEditMenu, clearItem);
//				EnableItem(gFindMenu, enterSelectionItem);
//				EnableItem(gFindMenu, findSelectionItem);
			}
			else
			{
				DisableItem(gEditMenu, cutItem);
				DisableItem(gEditMenu, copyItem);
				DisableItem(gEditMenu, clearItem);
//				DisableItem(gFindMenu, enterSelectionItem);
//				DisableItem(gFindMenu, findSelectionItem);
			}
			
			if (AnyTextQQ())
			{
				EnableItem(gEditMenu, selectAllItem);
			}
			else
			{
				DisableItem(gEditMenu, selectAllItem);
			}
			
//			if (AnythingToFindQQ())
//			{
//				EnableItem(gFindMenu, findAgainItem);
//				if (AnythingToReplaceQQ())
//				{
//					EnableItem(gFindMenu, replaceItem);
//					EnableItem(gFindMenu, replaceAndNextItem);
//				}
//				else
//				{
//					DisableItem(gFindMenu, replaceItem);
//					DisableItem(gFindMenu, replaceAndNextItem);
//				}
//			}
//			else
//			{
//				DisableItem(gFindMenu, findAgainItem);
//				DisableItem(gFindMenu, replaceItem);
//				DisableItem(gFindMenu, replaceAndNextItem);
//			}
			
			DisableItem(gEditMenu, undoItem);
		}
		else
		{
			EnableItem(gFileMenu, newItem);
			EnableItem(gFileMenu, openItem);
			DisableItem(gFileMenu, saveItem);
			DisableItem(gFileMenu, saveAsItem);
			DisableItem(gFileMenu, printItem);
			DisableItem(gOptionsMenu, resolveItem);
			
//			DisableItem(gFindMenu, 0);
			DisableItem(gInsertMenu, 0);
		}
		
		CheckItem(gOptionsMenu, alwaysResolveItem, gAlwaysResolve ? TRUE : FALSE);
		
		CheckItem(gSpeedMenu, delay0Item, (gSpeedDelay==0));
		CheckItem(gSpeedMenu, delay6Item, (gSpeedDelay==6));
		CheckItem(gSpeedMenu, delay12Item, (gSpeedDelay==12));
		CheckItem(gSpeedMenu, delay30Item, (gSpeedDelay==30));
		CheckItem(gSpeedMenu, delay60Item, (gSpeedDelay==60));
	}
}

void HandleMenu(long mSelect)
{
	short			menuID = HiWord(mSelect);
	short			menuItem = LoWord(mSelect);
	
	if (mSelect==0L)
	{
		mSelect=LMGetMenuDisable();
		menuID=HiWord(mSelect);
		menuItem=LoWord(mSelect);
		gMenuEnabled=FALSE;
	}
	else gMenuEnabled=TRUE;
	
	LMSetMenuDisable(0L);
	
	switch (menuID)
	{
		case appleMenu:
			HandleAppleMenu(menuItem);
			break;
		case fileMenu:
			HandleFileMenu(menuItem);
			break;	
		case editMenu:
			HandleEditMenu(menuItem);
			break;
		case optionsMenu:
			HandleOptionsMenu(menuItem);
			break;
		case insertMenu:
			HandleInsertMenu(menuItem);
			break;
//		case findMenu:
//			HandleFindMenu(menuItem);
//			break;
		case speedMenu:
			HandleSpeedMenu(menuItem);
			break;
	}
}

void DoTheCloseThing(WindowPeek theWindow)
/* a standard close procedure, called when "close" is chosen from File menu and when
   a window is closed through its close box */
{
	Boolean			gotone;
	short			i;
	short			kind;
	
	if (theWindow==0L)
		return;
	
	kind = theWindow ? theWindow->windowKind : 0;
	if (kind<0)		/* DA window or other system window */
		CloseDeskAcc(kind);
	else
	{
		gotone=FALSE;
		/* see if it's one of ours */
		for (i=0; (i<NUM_WINDOWS) && (!gotone); i++)
			gotone=((WindowPtr)theWindow==GetIndWindowPtr(i));
		
		if (gotone)		/* if it's one of ours...  see graphics.c */
			CloseTheIndWindow(i-1);			/* this may return FALSE = not closed */
		else
			DisposeWindow((WindowPtr)theWindow);	/* not one of ours, so just close it */
	
		AdjustMenus();	/* may affect which menu items or menus are available, etc */
		DrawMenuBar();
	}
}

void HandleAppleMenu(short menuItem)
{
	GrafPtr		savePort;
	Str255		name;
	
	if (!gMenuEnabled)
		return;
	if (menuItem==0)
		return;
	
	switch (menuItem)
	{
		case aboutItem:
			OpenTheIndWindow(kAboutWindow);
			break;
		case aboutMSGItem:
			OpenTheIndWindow(kAboutMSGWindow);
			break;
		case helpPointerItem:
			HandleHelpMenu();
			break;
		default:
			if (menuItem > helpPointerItem+1)
			{
				GetPort(&savePort);
				GetItem(gAppleMenu, menuItem, name);
				OpenDeskAcc(name);
				SetPort(savePort);
			}
			break;
	}
}

void HandleFileMenu(short menuItem)
{
	if (!gMenuEnabled)
		return;
	if (menuItem==0)
		return;
	
	switch (menuItem)
	{
		case newItem:
			OpenTheIndWindow(kMainWindow);
			break;
		case openItem:
			LoadSaveDispatch(TRUE, FALSE);
			break;
		case closeItem:
			DoTheCloseThing((WindowPeek)FrontWindow());
			break;
		case saveItem:
			LoadSaveDispatch(FALSE, TRUE);
			break;
		case saveAsItem:
			LoadSaveDispatch(FALSE, FALSE);
			break;
		case pageSetupItem:
			DoThePageSetup();
			break;
		case printItem:
			PrintText(GetTheTextHandle());
			break;
		case quitItem:
			gDone = TRUE;
			break;
	}
}

void HandleEditMenu(short menuItem)
{
	if (!gMenuEnabled)
		return;
	if (menuItem==0)
		return;
	
	if (gFrontWindowIsOurs)
	{
		switch (menuItem)
		{
			case undoItem:		CallIndDispatchProc(gFrontWindowIndex, kUndo, 0L);	break;
			case cutItem:		CallIndDispatchProc(gFrontWindowIndex, kCut, 0L);	break;
			case copyItem:		CallIndDispatchProc(gFrontWindowIndex, kCopy, 0L);	break;
			case pasteItem:		CallIndDispatchProc(gFrontWindowIndex, kPaste, 0L);	break;
			case clearItem:		CallIndDispatchProc(gFrontWindowIndex, kClear, 0L);	break;
			case selectAllItem:	CallIndDispatchProc(gFrontWindowIndex, kSelectAll, 0L);	break;
		}
	}
	else SystemEdit(menuItem-1);
}

void HandleOptionsMenu(short menuItem)
{
	if (!gMenuEnabled)
		return;
	if (menuItem==0)
		return;
	
	switch (menuItem)
	{
		case resolveItem:
			ParserDispatch((WindowDataHandle)GetWindowDataHandle(kMainWindow));
			break;
		case alwaysResolveItem:
			gAlwaysResolve=!gAlwaysResolve;
			AdjustMenus();
			break;
		case kantinuousItem:
			Kantinuous();
			break;
	}
}

void HandleHelpMenu(void)
{
	OpenTheIndWindow(kHelpWindow);
}

void HandleInsertMenu(short menuItem)
{
	if (!gMenuEnabled)
		return;
	if (menuItem==0)
		return;
	
	if (FrontWindow()!=GetIndWindowPtr(kMainWindow))
		SelectWindow(GetIndWindowPtr(kMainWindow));
	
	switch (menuItem)
	{
		case sectionItem:
			InsertTheText("\p&section");
			break;
		case paragraphItem:
			InsertTheText("\p&paragraph");
			break;
		case sentenceItem:
			InsertTheText("\p&sentence");
			break;
		case mainClauseItem:
			InsertTheText("\p&main-clause");
			break;
		case introClauseItem:
			InsertTheText("\p&intro-clause");
			break;
		case throwawayClauseItem:
			InsertTheText("\p&throwaway-clause");
			break;
		case proofItem:
			InsertTheText("\p&proof");
			break;
		case throwawaySentenceItem:
			InsertTheText("\p&throwaway-sentence");
			break;
	}
	
	if (gAlwaysResolve)
		ParserDispatch((WindowDataHandle)GetWindowDataHandle(kMainWindow));
}

//void HandleFindMenu(short menuItem)
//{
//	if (!gMenuEnabled)
//		return;
//	if (menuItem==0)
//		return;
//	
//	switch (menuItem)
//	{
//		case findItem:
//			DoFindDialog();
//			break;
//		case findAgainItem:
//			if (!DoFindAgain())
//				SysBeep(7);
//			break;
//	}
//}

void HandleSpeedMenu(short menuItem)
{
	if (!gMenuEnabled)
		return;
	if (menuItem==0)
		return;
	
	switch (menuItem)
	{
		case delay0Item:
			gSpeedDelay=0;
			break;
		case delay6Item:
			gSpeedDelay=6;
			break;
		case delay12Item:
			gSpeedDelay=12;
			break;
		case delay30Item:
			gSpeedDelay=30;
			break;
		case delay60Item:
			gSpeedDelay=60;
			break;
	}
	
	AdjustMenus();
}
