/*
 *	filter shell.c	Shell to implement MacDOS filters.
 *
 *	Released MacDOS 1.0.1a on 94/01/31
 *	94/03/31	File created
 *	94/05/26	First version completed
 *	Released MacDOS 2.0.02 on 94/06/07
 *	94/06/16	Changed name from filter.c to filter shell.c
 *
 *--------------------------------------------------------------------------------------------------
 *	Copyright  1994 by Rainbow Hill Pty Ltd.
 *
 *	This program is free software; you can redistribute it and/or modify it under the terms of
 *	the GNU General Public License as published by the Free Software Foundation; either version 2
 *	of the License, or any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this program;
 *	if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <Errors.h>
#include "pipe.h"

static pipeParmsFun_t	HandleParameters;
static OSErr			DoFiltering(unsigned char *, unsigned char *, unsigned char **);

main() {
	OSErr			os_err;
	unsigned char	*errInClear;
	unsigned char	inBuff[pipeSize];
	unsigned char	outBuff[pipeSize];

	/* initialisation */
	MaxApplZone();
	InitGraf(&thePort);
	InitWindows();
	InitDialogs(0L);
	InitCursor();

	/* NOTE: the Pipe functions never return in case of error */

	/* initialise the incoming pipe */
	PipeInit(HandleParameters);

	/*
	 *	Keep getting records from the master as long as no error occurs.
	 *	This replaces the event loop of standard Mac applications.
	 */
	while (true) {

		/* wait to receive the next record */
		PipePoll(inBuff);

		/* do the actual filtering */
		os_err = DoFiltering(inBuff, outBuff, &errInClear);
		if (os_err != noErr) PipeReportError(os_err, errInClear);

		/* pass the filtered buffer to the next filter via the outgoing pipe */
		PipeSendData(outBuff);
		}

	} /* main */

/*------------------------------------------------------------------------------ HandleParameters */
static OSErr HandleParameters(unsigned char *parms) {
	OSErr	retVal;

	retVal = noErr;

	/* HERE ANALYSE AND SAVE YOUR FILTER PARAMETERS FOR WHEN YOU DO THE FILTERING */

	return (retVal);
	} /* HandleParameters */

/*----------------------------------------------------------------------------------- DoFiltering */
static OSErr DoFiltering(unsigned char *inBuff, unsigned char *outBuff, unsigned char **errMess) {
	OSErr	retVal;

	/*
	 *	In case of error, assign the appropriate value to 'retVal'.
	 *	You can also use 'errMess' to report a proprietary error message as follows:
	 *		retVal = pipeFilteringErr;
	 *		*errMess = '\pmy error message";
	 *	MacDOS will display it in the console window.
	 */
	retVal = noErr;
	*errMess = nil;

	{	/* This just copies the input to the output. REPLACE IT WITH YOUR CODE. */
		short	k;
		for (k = (short)inBuff[0] + 1; k >= 0; k--) outBuff[k] = inBuff[k];
		}

	return (retVal);
	} /* DoFiltering */
